const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const chapters = sequelize.define(
    'chapters',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

title: {
        type: DataTypes.TEXT,
      
      

      },

chapter_number: {
        type: DataTypes.TEXT,
      
      

      },

sort_order: {
        type: DataTypes.INTEGER,
      
      

      },

summary: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  chapters.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












    db.chapters.hasMany(db.questions, {
      as: 'questions_chapter',
      foreignKey: {
          name: 'chapterId',
      },
      constraints: false,
    });



    db.chapters.hasMany(db.tests, {
      as: 'tests_chapter',
      foreignKey: {
          name: 'chapterId',
      },
      constraints: false,
    });













    db.chapters.hasMany(db.ai_generation_jobs, {
      as: 'ai_generation_jobs_chapter',
      foreignKey: {
          name: 'chapterId',
      },
      constraints: false,
    });



//end loop



    db.chapters.belongsTo(db.textbooks, {
      as: 'textbook',
      foreignKey: {
        name: 'textbookId',
      },
      constraints: false,
    });




    db.chapters.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.chapters.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return chapters;
};


